
        "use strict";

        const conversions = require("webidl-conversions");
        const utils = require("./utils.js");
        
      const HTMLConstructor_helpers_html_constructor = require("../helpers/html-constructor.js").HTMLConstructor;
const ceReactionsPreSteps_helpers_custom_elements = require("../helpers/custom-elements.js").ceReactionsPreSteps;
const ceReactionsPostSteps_helpers_custom_elements = require("../helpers/custom-elements.js").ceReactionsPostSteps;
const implSymbol = utils.implSymbol;
const ctorRegistrySymbol = utils.ctorRegistrySymbol;
const HTMLElement = require("./HTMLElement.js");

      
      const interfaceName = "HTMLFrameSetElement";
    
      exports.is = function is(obj) {
        return utils.isObject(obj) && utils.hasOwn(obj, implSymbol) && obj[implSymbol] instanceof Impl.implementation;
      };
      exports.isImpl = function isImpl(obj) {
        return utils.isObject(obj) && obj instanceof Impl.implementation;
      };
      exports.convert = function convert(obj, { context = "The provided value" } = {}) {
        if (exports.is(obj)) {
          return utils.implForWrapper(obj);
        }
        throw new TypeError(`${context} is not of type 'HTMLFrameSetElement'.`);
      };
    
      exports.create = function create(globalObject, constructorArgs, privateData) {
        if (globalObject[ctorRegistrySymbol] === undefined) {
          throw new Error('Internal error: invalid global object');
        }

        const ctor = globalObject[ctorRegistrySymbol]["HTMLFrameSetElement"];
        if (ctor === undefined) {
          throw new Error('Internal error: constructor HTMLFrameSetElement is not installed on the passed global object');
        }

        let obj = Object.create(ctor.prototype);
        obj = exports.setup(obj, globalObject, constructorArgs, privateData);
        return obj;
      };
      exports.createImpl = function createImpl(globalObject, constructorArgs, privateData) {
        const obj = exports.create(globalObject, constructorArgs, privateData);
        return utils.implForWrapper(obj);
      };
      exports._internalSetup = function _internalSetup(obj, globalObject) {
    
        HTMLElement._internalSetup(obj, globalObject);
      
      };
      exports.setup = function setup(obj, globalObject, constructorArgs = [], privateData = {}) {
        privateData.wrapper = obj;

        exports._internalSetup(obj, globalObject);
        Object.defineProperty(obj, implSymbol, {
          value: new Impl.implementation(globalObject, constructorArgs, privateData),
          configurable: true
        });
    
        obj[implSymbol][utils.wrapperSymbol] = obj;
        if (Impl.init) {
          Impl.init(obj[implSymbol], privateData);
        }
        return obj;
      };
    
      exports.install = function install(globalObject) {
    
        if (globalObject.HTMLElement === undefined) {
          throw new Error('Internal error: attempting to evaluate HTMLFrameSetElement before HTMLElement');
        }
      class HTMLFrameSetElement extends globalObject.HTMLElement {
        constructor() {
      return HTMLConstructor_helpers_html_constructor(globalObject, interfaceName, new.target);
    }
      
        get cols() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        
          const value = esValue[implSymbol].getAttributeNS(null, "cols");
          return value === null ? "" : value;
        
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
    }
      
        set cols(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
        V = conversions["DOMString"](V, { context: "Failed to set the 'cols' property on 'HTMLFrameSetElement': The provided value", });
      
        
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        
          esValue[implSymbol].setAttributeNS(null, "cols", V);
        
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
      }
      
        get rows() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        
          const value = esValue[implSymbol].getAttributeNS(null, "rows");
          return value === null ? "" : value;
        
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
    }
      
        set rows(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
        V = conversions["DOMString"](V, { context: "Failed to set the 'rows' property on 'HTMLFrameSetElement': The provided value", });
      
        
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        
          esValue[implSymbol].setAttributeNS(null, "rows", V);
        
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
      }
      
        get onafterprint() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onafterprint"]);
    }
      
        set onafterprint(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      if (V === null || V === undefined) {
        V = null;
      } else {
    
      V = utils.tryImplForWrapper(V);
    }
        esValue[implSymbol]["onafterprint"] = V;
      }
      
        get onbeforeprint() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onbeforeprint"]);
    }
      
        set onbeforeprint(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      if (V === null || V === undefined) {
        V = null;
      } else {
    
      V = utils.tryImplForWrapper(V);
    }
        esValue[implSymbol]["onbeforeprint"] = V;
      }
      
        get onbeforeunload() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onbeforeunload"]);
    }
      
        set onbeforeunload(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      if (V === null || V === undefined) {
        V = null;
      } else {
    
      V = utils.tryImplForWrapper(V);
    }
        esValue[implSymbol]["onbeforeunload"] = V;
      }
      
        get onhashchange() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onhashchange"]);
    }
      
        set onhashchange(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      if (V === null || V === undefined) {
        V = null;
      } else {
    
      V = utils.tryImplForWrapper(V);
    }
        esValue[implSymbol]["onhashchange"] = V;
      }
      
        get onlanguagechange() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onlanguagechange"]);
    }
      
        set onlanguagechange(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      if (V === null || V === undefined) {
        V = null;
      } else {
    
      V = utils.tryImplForWrapper(V);
    }
        esValue[implSymbol]["onlanguagechange"] = V;
      }
      
        get onmessage() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onmessage"]);
    }
      
        set onmessage(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      if (V === null || V === undefined) {
        V = null;
      } else {
    
      V = utils.tryImplForWrapper(V);
    }
        esValue[implSymbol]["onmessage"] = V;
      }
      
        get onmessageerror() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onmessageerror"]);
    }
      
        set onmessageerror(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      if (V === null || V === undefined) {
        V = null;
      } else {
    
      V = utils.tryImplForWrapper(V);
    }
        esValue[implSymbol]["onmessageerror"] = V;
      }
      
        get onoffline() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onoffline"]);
    }
      
        set onoffline(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      if (V === null || V === undefined) {
        V = null;
      } else {
    
      V = utils.tryImplForWrapper(V);
    }
        esValue[implSymbol]["onoffline"] = V;
      }
      
        get ononline() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["ononline"]);
    }
      
        set ononline(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      if (V === null || V === undefined) {
        V = null;
      } else {
    
      V = utils.tryImplForWrapper(V);
    }
        esValue[implSymbol]["ononline"] = V;
      }
      
        get onpagehide() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onpagehide"]);
    }
      
        set onpagehide(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      if (V === null || V === undefined) {
        V = null;
      } else {
    
      V = utils.tryImplForWrapper(V);
    }
        esValue[implSymbol]["onpagehide"] = V;
      }
      
        get onpageshow() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onpageshow"]);
    }
      
        set onpageshow(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      if (V === null || V === undefined) {
        V = null;
      } else {
    
      V = utils.tryImplForWrapper(V);
    }
        esValue[implSymbol]["onpageshow"] = V;
      }
      
        get onpopstate() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onpopstate"]);
    }
      
        set onpopstate(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      if (V === null || V === undefined) {
        V = null;
      } else {
    
      V = utils.tryImplForWrapper(V);
    }
        esValue[implSymbol]["onpopstate"] = V;
      }
      
        get onrejectionhandled() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onrejectionhandled"]);
    }
      
        set onrejectionhandled(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      if (V === null || V === undefined) {
        V = null;
      } else {
    
      V = utils.tryImplForWrapper(V);
    }
        esValue[implSymbol]["onrejectionhandled"] = V;
      }
      
        get onstorage() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onstorage"]);
    }
      
        set onstorage(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      if (V === null || V === undefined) {
        V = null;
      } else {
    
      V = utils.tryImplForWrapper(V);
    }
        esValue[implSymbol]["onstorage"] = V;
      }
      
        get onunhandledrejection() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onunhandledrejection"]);
    }
      
        set onunhandledrejection(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      if (V === null || V === undefined) {
        V = null;
      } else {
    
      V = utils.tryImplForWrapper(V);
    }
        esValue[implSymbol]["onunhandledrejection"] = V;
      }
      
        get onunload() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onunload"]);
    }
      
        set onunload(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      if (V === null || V === undefined) {
        V = null;
      } else {
    
      V = utils.tryImplForWrapper(V);
    }
        esValue[implSymbol]["onunload"] = V;
      }
      }Object.defineProperties(HTMLFrameSetElement.prototype, { cols: { enumerable: true }, rows: { enumerable: true }, onafterprint: { enumerable: true }, onbeforeprint: { enumerable: true }, onbeforeunload: { enumerable: true }, onhashchange: { enumerable: true }, onlanguagechange: { enumerable: true }, onmessage: { enumerable: true }, onmessageerror: { enumerable: true }, onoffline: { enumerable: true }, ononline: { enumerable: true }, onpagehide: { enumerable: true }, onpageshow: { enumerable: true }, onpopstate: { enumerable: true }, onrejectionhandled: { enumerable: true }, onstorage: { enumerable: true }, onunhandledrejection: { enumerable: true }, onunload: { enumerable: true }, [Symbol.toStringTag]: { value: "HTMLFrameSetElement", configurable: true } });
        if (globalObject[ctorRegistrySymbol] === undefined) {
          globalObject[ctorRegistrySymbol] = Object.create(null);
        }
        globalObject[ctorRegistrySymbol][interfaceName] = HTMLFrameSetElement;

        Object.defineProperty(globalObject, interfaceName, {
          configurable: true,
          writable: true,
          value: HTMLFrameSetElement
        });
      };
    
    
        const Impl = require("../nodes/HTMLFrameSetElement-impl.js");
      